import { colors, palette } from "./colors";

const thickBorder = 2;
const bigRadius = 16;
const titleTextSize = 24;
const minTouchable = 48;

export const styles = {
  menu: {
    display: 'flex',
    flexDirection: 'row',
    justifyContent: 'center',
  },
  menuItem: {
    flex: 1,
    margin: '1em',
    maxWidth: '16em',
    borderColor: colors.neutralGray,
    borderWidth: thickBorder,
    borderStyle: 'solid',
    borderRadius: bigRadius,
    display: 'flex',
    flexDirection: 'column',
    backgroundColor: palette.disabledButton,
  },
  menuImage: ({ disabled }) => ({
    display: 'flex',
    flex: 1,
    width: '100%',
    borderTopLeftRadius: bigRadius - thickBorder,
    borderTopRightRadius: bigRadius - thickBorder,
    opacity: disabled ? 0.2 : 1,
  }),
  menuFooter: ({ disabled }) => ({
    display: 'block',
    color: 'white',
    fontSize: titleTextSize,
    textShadow: `0.1em 0.1em 0.04em ${colors.neutralGray}`,
    backgroundColor: disabled ? palette.disabledButton : colors.darkGray,
    paddingTop: '0.5em',
    paddingBottom: '0.5em',
    flex: 0,
    flexDirection: 'row',
    justifyContent: 'center',
    borderBottomLeftRadius: bigRadius - thickBorder,
    borderBottomRightRadius: bigRadius - thickBorder,
  }),
  menuTitle: {
    display: 'inline-block',
    width: '100%',
    textAlign: 'center',
  },
  logo: {
    display: 'inline-block',
    fontSize: 36,
    // borderStyle: 'dashed',
    padding: 2,
    // borderColor: colors.neutralGray,
    // borderWidth: thickBorder,
  },
  profileButton: {
    position: 'absolute',
    right: 0,
    display: 'flex',
    flexDirection: 'row',
    alignItems: 'center',
  },
  profileImage: {
    width: minTouchable,
    height: minTouchable,
    display: 'flex',
    borderColor: colors.lightGray,
    borderWidth: 1,
    borderStyle: 'solid',
  },
  profileText: {
    paddingLeft: '0.5em',
    paddingRight: '0.5em',
  },
  nav: {
    display: 'flex',
    flexDirection: 'row',
    justifyContent: 'flex-start',
    alignItems: 'center',
    position: 'fixed',
    top: '0',
    width: '100%',
    zIndex: '100',
    backgroundColor: 'white',
    borderBottom: 'rgba(210,210,210,0.9) solid 3px'
  },
  topics: {
    display: 'flex',
    flexDirection: 'row',
    flexWrap: 'wrap',
  },
  topicCheckbox: {
    marginRight: '2em',
  },
  form: {
    // maxWidth: 640,
  },
  centerContent: {
    display: 'flex',
    flexDirection: 'column',
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
  },
  button: ({ disabled, backgroundColor }) => ({
    display: 'inline',
    backgroundColor: disabled ? palette.disabledButton
      : backgroundColor || palette.actionButton,
    color: 'white',
    borderRadius: 8,
    minHeight: 32,
    paddingLeft: '1em',
    paddingRight: '1em',
  }),
  placeholderButton: {
    display: 'inline',
    backgroundColor: palette.actionButton,
    color: 'white',
    borderRadius: 8,
    minHeight: 32,
    paddingLeft: '1em',
    paddingRight: '1em',
  },
  latexEditor: {
    width: '100%',
  },
  latexField: {
    display: 'flex',
    flexDirection: 'row',
    justifyContent: 'center',
    borderBottomWidth: thickBorder,
    borderBottomColor: colors.neutralGray,
    paddingBottom: '1em',
    borderBottomStyle: 'solid',
  },
  wallOfText: {
    maxWidth: '48em',
    paddingLeft: '3em',
    paddingRight: '3em',
    textAlign: 'justify',
  },
  scrollView: {
    display: 'flex',
    flexDirection: 'column',
    flex: 1,
    overflowY: 'auto',
    marginTop: '55px',
  },
  rowCenter: {
    display: 'flex',
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center',
  },
  challengeRadio: {
    fontSize: 16,
    padding: '1em',
  },
  examList: {
    display: 'flex',
    flexDirection: 'row',
    flexWrap: 'wrap',
    justifyContent: 'center',
  },
  field: {
    marginTop: '0.5em',
    marginBottom: '1em',
    minHeight: minTouchable,
    marginLeft: 8,
  },
  fieldLabel: ({ color }) => ({
    color,
  }),
  fieldInput: ({ color }) => ({
    borderWidth: 0,
    borderBottomWidth: 2,
    borderBottomColor: color,
    borderBottomStyle: 'solid',
    fontSize: 16,
    flex: 1,
  }),
  breadcrumb: {
    fontSize: 24,
  },
  problemSummary: {
    borderColor: colors.neutralGray,
    borderWidth: 1,
    borderStyle: 'solid',
    borderRadius: 8,
    backgroundColor: 'white',
    padding: '1em',
    marginLeft: '2em',
    marginRight: '2em',
  },
  bigForm: {},
  modal: {
    marginTop: 64,
  },
  validationIcon: {
    marginLeft: 8,
    marginRight: 8,
  },
  fieldColumns: {
    display: 'flex',
    flexDirection: 'row',
    flexWrap: 'wrap',
  },
  fieldColumn: {
    display: 'flex',
    flexDirection: 'column',
    flex: 1,
    marginLeft: '4em',
    marginRight: '4em',
    width: '32em',
    minWidth: '16em',
  },
  blockTopicProblems: {
    backgroundColor: '#E7EBF0',
    borderRadius: 8,
    borderColor: colors.neutralGray,
    borderWidth: 1,
    borderStyle: 'solid',
    paddingLeft: '1em',
    paddingRight: '1em',
  },
  imagePreview: {
    width: 256, height: 256,
    minWidth: 256, minHeight: 256,
    position: 'relative',
    display: 'flex',
    flexDirection: 'column',
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
    borderStyle: 'solid',
    borderWidth: 1,
    borderColor: colors.neutralGray,
    margin: 4,
  },
};